#version 450

struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    mat4 gCameraNoHeadTrackingMat4;
    mat4 gPrevViewProjectionMat4;
    mat4 gThisToPrevViewProjectionMat4;
    mat4 gInverseViewMat4;
    mat4 gInverseProjectionMat4;
    mat4 gInverseProjectionSCMat4;
    mat4 gInverseViewProjectionMat4;
    vec4 gInverseWorldUpMatVec4[3];
    vec3 gViewPositionVec3;
    float gfTime;
    vec3 gVREyeInfoVec3;
    float gfPrevTime;
    vec4 gClipPlanesVec4;
    vec4 gMBlurSettingsVec4;
    vec3 gDeJitterVec3;
    int giFrameIndex;
    vec4 gTaaSettingsVec4;
    vec4 gTessSettingsVec4;
    vec4 gShellsSettingsVec4;
    vec4 gFrameBufferSizeVec4;
    vec4 gFoVValuesVec4;
    vec4 gShadowSizeVec4;
    vec3 gShadowProjScaleVec3;
    int giDisableAmbientAllowed;
    vec4 gShadowFadeParamVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    mat4 gWorldNormalMat4;
    float gfFadeValue;
    vec4 gLightColourVec4;
    vec4 gLightCustomParamsVec4;
    mat4 gWorldMotionMat4;
    mat4 gInverseModelMat4;
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
    vec4 gMaterialParamsVec4;
    vec4 gMaterialColourVec4;
    vec4 gMaterialSFXVec4;
    vec4 gMaterialSFXColVec4;
    vec4 gSunPositionVec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gCustomParams02Vec4;
    vec4 gObjectColourVec4;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _507;

layout(set = 1, binding = 2) uniform sampler2D gFadeNoiseMap;
layout(set = 1, binding = 3) uniform sampler2D gBufferMap;
layout(set = 1, binding = 0) uniform sampler2D gDiffuseMap;
layout(set = 1, binding = 1) uniform sampler2D gMasksMap;

layout(location = 0) in VertexBlock
{
    vec4 mTexCoordsVec4;
    vec4 mWorldPositionVec3_mfSpare;
    vec3 mTangentSpaceNormalVec3;
    vec4 mScreenSpacePositionVec4;
    flat vec3 mfFadeValueForInstance_mfLodIndex_mfShearMotionLength;
} In;

layout(location = 0) out vec4 out_color0;
layout(location = 1) out vec4 out_color1;
layout(location = 2) out vec4 out_color2;
layout(location = 3) out vec4 out_color3;

vec4 _1302;

void main()
{
    if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 1.0)
    {
        vec3 _906 = floor(In.mWorldPositionVec3_mfSpare.xyz);
        vec3 _908 = fract(In.mWorldPositionVec3_mfSpare.xyz);
        vec4 _928 = textureLod(gFadeNoiseMap, (_906.xy + (vec2(37.0, 17.0) * _906.z)) + ((_908 * _908) * (vec3(3.0) - (_908 * 2.0))).xy, 0.0);
        float _929 = _928.x;
        if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 0.0)
        {
            if ((1.0 - _929) > (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x + 2.0))
            {
                discard;
            }
        }
        else
        {
            if (_929 > In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x)
            {
                discard;
            }
        }
    }
    vec2 _970 = ((In.mScreenSpacePositionVec4.xy / vec2(In.mScreenSpacePositionVec4.w)) * 0.5) + vec2(0.5);
    vec2 _1073 = (_970 * 2.0) - vec2(1.0);
    vec4 _1266 = vec4(_1073.x, _1073.y, _1302.z, _1302.w);
    _1266.z = (((_507.lUniforms.mpPerFrame.gClipPlanesVec4.x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y) / (texture(gBufferMap, vec2(_970.x, 1.0 - _970.y)).x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y)) - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x) / (_507.lUniforms.mpPerFrame.gClipPlanesVec4.y - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x);
    
    _1266.x-=vk3d_params.stereo.x*(1-vk3d_params.stereo.y*_1266.z*10);
    
    vec4 _1268 = _1266;
    _1268.w = 1.0;
    vec4 _1083 = _507.lUniforms.mpPerFrame.gInverseViewProjectionMat4 * _1268;
    vec3 _999 = (_507.lUniforms.mpCommonPerMesh.gInverseModelMat4 * vec4((_1083.xyz / vec3(_1083.w)).xyz + _507.lUniforms.mpPerFrame.gViewPositionVec3, 1.0)).xyz + vec3(0.5);
    float _1002 = 1.0 - _999.y;
    vec3 _1272 = _999;
    _1272.y = _1002;
    float _1005 = _999.x;
    bool _1006 = _1005 < 0.0;
    bool _1013;
    if (!_1006)
    {
        _1013 = _1005 >= 1.0;
    }
    else
    {
        _1013 = _1006;
    }
    bool _1020;
    if (!_1013)
    {
        _1020 = _1002 < 0.0;
    }
    else
    {
        _1020 = _1013;
    }
    bool _1027;
    if (!_1020)
    {
        _1027 = _1002 >= 1.0;
    }
    else
    {
        _1027 = _1020;
    }
    bool _1034;
    if (!_1027)
    {
        _1034 = _999.z < 0.0;
    }
    else
    {
        _1034 = _1027;
    }
    bool _1041;
    if (!_1034)
    {
        _1041 = _999.z >= 1.0;
    }
    else
    {
        _1041 = _1034;
    }
    if (_1041)
    {
        discard;
    }
    vec4 _629 = texture(gDiffuseMap, _1272.xy);
    vec4 _635 = texture(gMasksMap, _1272.xy);
    float _641 = _629.w * _507.lUniforms.mpCustomPerMaterial.gMaterialColourVec4.w;
    if (_641 < 9.9999997473787516355514526367188e-05)
    {
        discard;
    }
    vec4 _1287 = _1302;
    _1287.x = 0.0;
    vec4 _1289 = _1287;
    _1289.y = sqrt(((1.0 - _635.y) * _507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.x) * 0.5);
    vec4 _1291 = _1289;
    _1291.z = clamp(_507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.z, 0.0, 1.0);
    vec4 _1293 = _1291;
    _1293.w = 0.0;
    out_color0 = vec4(_629.xyz, _641);
    out_color1 = vec4(0.0);
    out_color2 = vec4(0.0);
    out_color3 = _1293;
}


